"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createDuck = void 0;
var createReducer_1 = require("./createReducer");
var createAction_1 = require("./createAction");
function getNS(name, actionType) {
    return name + "/" + actionType;
}
function createDuck(_a) {
    var name = _a.name, initialState = _a.initialState, reducers = _a.reducers, selectors = _a.selectors;
    var actions = {};
    var namespacedActionTypeMapping = {};
    for (var _i = 0, _b = Object.keys(reducers); _i < _b.length; _i++) {
        var actionType = _b[_i];
        actions[actionType] = createAction_1.createAction(actionType);
        namespacedActionTypeMapping[getNS(name, actionType)] = actionType;
    }
    var reducer = createReducer_1.createReducer(initialState, reducers, namespacedActionTypeMapping);
    return {
        actions: actions,
        initialState: initialState,
        name: name,
        reducer: reducer,
        selectors: selectors,
    };
}
exports.createDuck = createDuck;
