"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createReducer = void 0;
var isActionType = function (a, mapping) {
    return Boolean(Object.prototype.hasOwnProperty.call(mapping, a.type));
};
function createReducer(initialState, actionTypeToReducer, namespacedActionTypeMapping, defaultReducer) {
    var isReducerActionType = function (a) {
        return isActionType(a, actionTypeToReducer);
    };
    var isNamespacedActionType = function (a) {
        return isActionType(a, namespacedActionTypeMapping);
    };
    return function (state, action) {
        var _a;
        if (state === void 0) { state = initialState; }
        if (action !== undefined && isReducerActionType(action)) {
            return actionTypeToReducer[action.type](state, action);
        }
        else if (action !== undefined &&
            namespacedActionTypeMapping !== undefined &&
            isNamespacedActionType(action)) {
            var actionType = namespacedActionTypeMapping[action.type];
            return actionTypeToReducer[actionType](state, __assign(__assign({}, action), { type: actionType }));
        }
        return (_a = defaultReducer === null || defaultReducer === void 0 ? void 0 : defaultReducer(state, action)) !== null && _a !== void 0 ? _a : state;
    };
}
exports.createReducer = createReducer;
