"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createRootDuck = void 0;
var combineReducers_1 = require("./utils/combineReducers");
function createRootDuck() {
    var ducks = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        ducks[_i] = arguments[_i];
    }
    var rootDuck = {
        actions: {},
        initialState: {},
        names: new Set(ducks.map(function (d) { return d.name; })),
        selectors: {},
    };
    var reducerMapping = {};
    for (var _a = 0, ducks_1 = ducks; _a < ducks_1.length; _a++) {
        var duck = ducks_1[_a];
        var duckName = duck.name;
        rootDuck.actions[duckName] = duck.actions;
        rootDuck.initialState[duckName] = duck.initialState;
        rootDuck.selectors[duckName] = duck.selectors;
        reducerMapping[duckName] = duck.reducer;
    }
    rootDuck.reducer = combineReducers_1.combineReducers(rootDuck.initialState, reducerMapping);
    return rootDuck;
}
exports.createRootDuck = createRootDuck;
