"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.combineReducers = void 0;
function combineReducers(initialState, reducerMapping) {
    var reducers = Object.entries(reducerMapping);
    return function (state, action) {
        if (state === void 0) { state = initialState; }
        return reducers.reduce(function (acc, _a) {
            var name = _a[0], reducer = _a[1];
            acc[name] = reducer(state[name], action);
            return acc;
        }, {});
    };
}
exports.combineReducers = combineReducers;
